PWRAddonName, PWRAddonTitle, PWRAddonNotes = GetAddOnInfo("Powered")
PWRTexturesPath = "Interface\\AddOns\\" .. PWRAddonName .. "\\skins\\"
PWRBordersPath = "Interface\\UNITPOWERBARALT\\"

PWRBorderChoices = {
	{ Label = "Default", Value = 			PWRBordersPath .. "WowUI_Horizontal_Frame" },
	{ Label = "Air", Value = 				PWRBordersPath .. "Air_Horizontal_Frame" },
	{ Label = "Fire", Value = 				PWRBordersPath .. "Fire_Horizontal_Frame" },
	{ Label = "Ice", Value = 				PWRBordersPath .. "Ice_Horizontal_Frame" },
	{ Label = "Water", Value = 				PWRBordersPath .. "Water_Horizontal_Frame" },
	{ Label = "Alliance", Value = 			PWRBordersPath .. "Alliance_Horizontal_Frame" },
	{ Label = "Horde", Value = 				PWRBordersPath .. "Horde_Horizontal_Frame" },
	{ Label = "Meat", Value = 				PWRBordersPath .. "Meat_Horizontal_Frame" },
	{ Label = "Meat (Undead)", Value = 		PWRBordersPath .. "UndeadMeat_Horizontal_Frame" },
	{ Label = "Stone (Diamond)", Value = 	PWRBordersPath .. "StoneDiamond_Horizontal_Frame" },
	{ Label = "Stone (Tan)", Value = 		PWRBordersPath .. "StoneTan_Horizontal_Frame" },
	{ Label = "Stone (Design)", Value = 	PWRBordersPath .. "StoneDesign_Horizontal_Frame" },
	{ Label = "Rock", Value = 				PWRBordersPath .. "Rock_Horizontal_Frame" },
	{ Label = "Rock (Molten)", Value = 		PWRBordersPath .. "MoltenRock_Horizontal_Frame" },
	{ Label = "Onyxia", Value = 			PWRBordersPath .. "Onyxia_Horizontal_Frame" },
	{ Label = "Chogall", Value = 			PWRBordersPath .. "Chogall_Horizontal_Frame" },
	{ Label = "Mechanical", Value = 		PWRBordersPath .. "Mechanical_Horizontal_Frame" },
	{ Label = "Metal", Value = 				PWRBordersPath .. "MetalPlain_Horizontal_Frame" },
	{ Label = "Metal (Bronze)", Value = 	PWRBordersPath .. "MetalBronze_Horizontal_Frame" },
	{ Label = "Metal (Eternium)", Value = 	PWRBordersPath .. "MetalEternium_Horizontal_Frame" },
	{ Label = "Metal (Gold)", Value = 		PWRBordersPath .. "MetalGold_Horizontal_Frame" },
	{ Label = "Metal (Rusted)", Value = 	PWRBordersPath .. "MetalRusted_Horizontal_Frame" },
	{ Label = "Wood Boards", Value = 		PWRBordersPath .. "WoodBoards_Horizontal_Frame" },
	{ Label = "Wood Plank", Value = 		PWRBordersPath .. "WoodPlank_Horizontal_Frame" },
	{ Label = "Wood Vertical", Value = 		PWRBordersPath .. "WoodVerticalPlanks_Horizontal_Frame" },
	{ Label = "Wood With Metal", Value = 	PWRBordersPath .. "WoodWithMetal_Horizontal_Frame" },
	{ Label = "No Skin", Value = 			"nil" },
}

PWRBarSkins = {
	{ Label = "Default", Value =			"Interface\\TargetingFrame\\UI-StatusBar" },
	{ Label = "Perl", Value =				PWRTexturesPath .."perl" },
	{ Label = "Ace", Value =				PWRTexturesPath .."AceBarFrames" },
	{ Label = "Aluminium", Value =			PWRTexturesPath .."Aluminium" },
	{ Label = "Banto", Value =				PWRTexturesPath .."banto" },
	{ Label = "Charcoal", Value =			PWRTexturesPath .."Charcoal" },
	{ Label = "Glaze", Value =				PWRTexturesPath .."glaze" },
	{ Label = "LiteStep", Value =			PWRTexturesPath .."LiteStep" },
	{ Label = "Minimalist", Value =			PWRTexturesPath .."Minimalist" },
	{ Label = "Otravi", Value =				PWRTexturesPath .."otravi" },
	{ Label = "Smooth", Value =				PWRTexturesPath .."smooth" },
	{ Label = "XPerl 1", Value =			PWRTexturesPath .."XPerl_StatusBar" },
	{ Label = "XPerl 2", Value =			PWRTexturesPath .."XPerl_StatusBar2" },
	{ Label = "XPerl 3", Value =			PWRTexturesPath .."XPerl_StatusBar3" },
	{ Label = "XPerl 4", Value =			PWRTexturesPath .."XPerl_StatusBar5" },
	{ Label = "XPerl 5", Value =			PWRTexturesPath .."XPerl_StatusBar6" },
	{ Label = "XPerl 6", Value =			PWRTexturesPath .."XPerl_StatusBar7" },
	{ Label = "XPerl 7", Value =			PWRTexturesPath .."XPerl_StatusBar8" },
	
}

PWRAlignments = {
	{ Label = "Left", Value = "LEFT" },
	{ Label = "Center", Value = "CENTER" },
	{ Label = "Right", Value = "RIGHT" },
}

PWRDefaultBarWidth = 200
PWRIsInCombat = false

SLASH_POWERED1, SLASH_POWERED2 = "/powered", "/pwr"

function SlashCmdList.POWERED(msg, editbox)
	InterfaceOptionsFrame_OpenToCategory(PWROptionsPanel) -- Need two times because the first one will only open the general option window
	InterfaceOptionsFrame_OpenToCategory(PWROptionsPanel) -- and the second one will focus on this addon's Options Panel. Yes its stupid. Deal with it.
end

function PWRLoadAddon()
	if (not PWRLoaded) then
		PWRLoaded = true
		PerSettings = PerSettings or {}
		-- SET DEFAULT VALUES IF THERE IS NONE
		if (PerSettings.IsLocked == nil) then PerSettings.IsLocked = false end
		
		PerSettings.SpecsInfo = PerSettings.SpecsInfo or {}
		for i = 1, GetNumSpecializations() do
			PerSettings.SpecsInfo[i] = PerSettings.SpecsInfo[i] or {}
			local specSettings = PerSettings.SpecsInfo[i]
			if (specSettings.ShowSpec == nil) then specSettings.ShowSpec = true end
			if (specSettings.IsOnlyInCombat == nil) then specSettings.IsOnlyInCombat = false end
			
			if (specSettings.ShowPercent == nil) then specSettings.ShowPercent = true end
			if (specSettings.ShowCurrent == nil) then specSettings.ShowCurrent = true end
			if (specSettings.ShowMax == nil) then specSettings.ShowMax = true end
			
			if (specSettings.BorderChoice == nil) then specSettings.BorderChoice = PWRBorderChoices[1].Value end
			if (specSettings.BarSkin == nil) then specSettings.BarSkin = PWRBarSkins[1].Value end
			
			if (specSettings.CurrentAlign == nil) then specSettings.CurrentAlign = PWRAlignments[1].Value end
			if (specSettings.PercentAlign == nil) then specSettings.PercentAlign = PWRAlignments[2].Value end
			if (specSettings.MaxAlign == nil) then specSettings.MaxAlign = PWRAlignments[3].Value end
			
			if (specSettings.UseCustomColor == nil) then specSettings.UseCustomColor = false end
			if (specSettings.CustomColor == nil) then specSettings.CustomColor = { r = 0.5, g = 0.5, b = 0.5 } end
			
			if (specSettings.Length == nil) then specSettings.Length = PWRDefaultBarWidth end
			
			if (specSettings.Scale == nil) then specSettings.Scale = 1 end
		end
		-- END SET DEFAULT
		
		-- Patch for 1.0 to 1.1 (So as to not discard player's settings) BEGIN
		if (PerSettings.ShowSpec) then
			for i = 1, GetNumSpecializations() do
				PerSettings.SpecsInfo[i].ShowSpec = PerSettings.ShowSpec
				PerSettings.SpecsInfo[i].IsOnlyInCombat = PerSettings.IsOnlyInCombat
				PerSettings.SpecsInfo[i].ShowPercent = PerSettings.ShowPercent
				PerSettings.SpecsInfo[i].ShowCurrent = PerSettings.ShowCurrent
				PerSettings.SpecsInfo[i].ShowMax = PerSettings.ShowMax
				PerSettings.SpecsInfo[i].XPos = PerSettings.XPos
				PerSettings.SpecsInfo[i].YPos = PerSettings.YPos
				PerSettings.SpecsInfo[i].BorderChoice = PerSettings.BorderChoice[i]
			end
			PerSettings.ShowSpec = nil
			PerSettings.IsOnlyInCombat = nil
			PerSettings.ShowPercent = nil
			PerSettings.ShowCurrent = nil
			PerSettings.ShowMax = nil
			PerSettings.BorderChoiceID = nil
			PerSettings.BorderChoice = nil
			PerSettings.XPos = nil
			PerSettings.YPos = nil
		end
		-- Patch for 1.0 to 1.1 END
		
		if (PerSettings.IsLocked) then
			mainFrame:SetMovable(false)
			mainFrame:EnableMouse(false)
		end
		
		local currentSpecID = GetSpecialization()
		
		mainFrame:SetScale(PerSettings.SpecsInfo[currentSpecID].Scale)
		if (PerSettings.SpecsInfo[currentSpecID].XPos) then
			mainFrame:ClearAllPoints()
			mainFrame:SetPoint("BOTTOMLEFT", PerSettings.SpecsInfo[currentSpecID].XPos, PerSettings.SpecsInfo[currentSpecID].YPos)
		end
		if (PerSettings.SpecsInfo[currentSpecID].IsOnlyInCombat) then
			mainFrame:Hide()
		end
		if (not PerSettings.SpecsInfo[currentSpecID].ShowCurrent) then
			mainFrame.Current:Hide()
		end
		if (not PerSettings.SpecsInfo[currentSpecID].ShowPercent) then
			mainFrame.Percent:Hide()
		end
		if (not PerSettings.SpecsInfo[currentSpecID].ShowMax) then
			mainFrame.Max:Hide()
		end
		if (not PerSettings.SpecsInfo[currentSpecID].ShowSpec) then
			mainFrame:Hide()
		end
		
		mainFrame:SetStatusBarTexture(PerSettings.SpecsInfo[currentSpecID].BarSkin)
		mainFrame.BG:SetTexture(PerSettings.SpecsInfo[currentSpecID].BarSkin)
		
		PWRSetVisible(mainFrame.Border, PerSettings.SpecsInfo[currentSpecID].BorderChoice)
		mainFrame.Border:SetTexture(PerSettings.SpecsInfo[currentSpecID].BorderChoice)
		
		PWRRefreshLength(currentSpecID)
		
		PWRLoadOptionsPanel()
		PWRRefreshPowerColor(currentSpecID)
		
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff[Powered]|c00ff00ff Addon loaded!")
	end
end

function PWRLog(msg)
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff[Powered]|c00ff00ff " .. msg)
end

function PWRShowColorPicker(rgb, changedCallback)
	ColorPickerFrame.previousValues = { rgb.r, rgb.g, rgb.b }
	ColorPickerFrame.hasOpacity = false
	ColorPickerFrame.func, ColorPickerFrame.opacityFunc, ColorPickerFrame.cancelFunc = changedCallback, changedCallback, changedCallback
	ColorPickerFrame:SetColorRGB(rgb.r, rgb.g, rgb.b)
	ColorPickerFrame:Show()
end

function PWRSetVisible(var, state)
	if (state == "nil") then
		var:Hide()
	elseif (state) then
		var:Show()
	else
		var:Hide()
	end
end

function PWRFloorIfNotWhole(v)
	if (floor(v) == not v) then
		return floor(v)
	else
		return v
	end
end

function PWRAlignLabel(label, align, specID)
	local widthFactor = PerSettings.SpecsInfo[specID].Length / PWRDefaultBarWidth
	if (align == PWRAlignments[1].Value) then
		label:ClearAllPoints()
		label:SetPoint("LEFT", 8 * widthFactor, 0)
	elseif (align == PWRAlignments[2].Value) then
		label:ClearAllPoints()
		label:SetPoint("CENTER", 0, -1)
	elseif (align == PWRAlignments[3].Value) then
		label:ClearAllPoints()
		label:SetPoint("RIGHT", -8 * widthFactor, 0)
	end
end

function PWRCreateDropdownMenu(name, index, source, width, useValueAsIcon, onChange)
	local menu = CreateFrame("Frame", name .. index, PWROptionsPanel.Content, "UIDropDownMenuTemplate")
	menu.PWROnChange = onChange
	menu.PWRSource = source
	menu.PWRUseValueAsIcon = useValueAsIcon
	UIDropDownMenu_Initialize(menu, PWRDropMenu_Init)
	UIDropDownMenu_SetWidth(menu, width);
	UIDropDownMenu_SetButtonWidth(menu, 124)
	UIDropDownMenu_JustifyText(menu, "LEFT")
	return menu
end

function PWRCreateDropdownColorMenu(name, index, source, width, onChange)
	local menu = CreateFrame("Frame", name .. index, PWROptionsPanel.Content, "UIDropDownMenuTemplate")
	menu.PWROnChange = onChange
	menu.PWRSource = source
	UIDropDownMenu_Initialize(menu, PWRDropMenu_Init)
	UIDropDownMenu_SetWidth(menu, width);
	UIDropDownMenu_SetButtonWidth(menu, 124)
	UIDropDownMenu_JustifyText(menu, "LEFT")
	return menu
end

function PWRDropMenu_Init(menu)
	local info = UIDropDownMenu_CreateInfo()
	for j,v in ipairs(menu.PWRSource) do
		info = UIDropDownMenu_CreateInfo()
		info.text = v.Label
		info.value = v.Value
		if (menu.PWRUseValueAsIcon and v.Value ~= "nil") then
			info.icon = v.Value
		end
		info.func = function(self)
			UIDropDownMenu_SetSelectedID(menu, j)
			menu.PWROnChange(j, v.Value)
		end
		UIDropDownMenu_AddButton(info, 1)
	end
end

function PWRRefreshLength(specID)
	mainFrame:SetWidth(PerSettings.SpecsInfo[specID].Length)
	local widthFactor = PerSettings.SpecsInfo[specID].Length / PWRDefaultBarWidth
	mainFrame.Border:ClearAllPoints()
	mainFrame.Border:SetPoint("TOPLEFT", -38 * widthFactor, 12)
	mainFrame.Border:SetPoint("BOTTOMRIGHT", 38 * widthFactor, -12)
	PWRAlignLabel(mainFrame.Current, PerSettings.SpecsInfo[specID].CurrentAlign, specID)
	PWRAlignLabel(mainFrame.Percent, PerSettings.SpecsInfo[specID].PercentAlign, specID)
	PWRAlignLabel(mainFrame.Max, PerSettings.SpecsInfo[specID].MaxAlign, specID)
end

function PWRPowerUpdate(...)
	local arg1 = ...
	if (arg1 == "player") then
		local power = UnitPower("player")
		mainFrame:SetValue(power)
		PWRRefreshValues(power)
	end
end

function PWRGetPowerColor()
	local powerType, powerToken, altR, altG, altB = UnitPowerType("player");
	local info = PowerBarColor[powerToken];
	if (info) then
		r, g, b = info.r, info.g, info.b;
	elseif ( not altR) then
		info = PowerBarColor[powerType] or PowerBarColor["MANA"];
		r, g, b = info.r, info.g, info.b;
	else
		r, g, b = altR, altG, altB;
	end
	return r, g, b
end

function PWRGetCustomColor(specID)
	return PerSettings.SpecsInfo[specID].CustomColor.r, PerSettings.SpecsInfo[specID].CustomColor.g, PerSettings.SpecsInfo[specID].CustomColor.b
end

function PWRRefreshPowerColor(specID)
	local r, g, b = 0,0,0
	if (PerSettings.SpecsInfo[specID].UseCustomColor) then
		r, g, b = PWRGetCustomColor(specID)
	else
		r, g, b = PWRGetPowerColor()
	end
	mainFrame:SetStatusBarColor(r, g, b)
	mainFrame.BG:SetVertexColor(r * 0.25, g * 0.25, b * 0.25, 0.7)
	PWRRefreshPowerRange()
end

function PWRRefreshPowerRange()
	local power = UnitPower("player")
	PWRCurrentMaxPower = UnitPowerMax("player")
	mainFrame:SetMinMaxValues(0, PWRCurrentMaxPower)
	mainFrame.Max:SetText(PWRReadableNumber(PWRCurrentMaxPower))
	mainFrame:SetValue(power)
	PWRRefreshValues(power)
end

function PWRRefreshValues(power)
	mainFrame.Current:SetText(PWRReadableNumber(power))
	if (PWRCurrentMaxPower == 0) then
		mainFrame.Percent:SetText("N/A%")
	else
		local percent = floor((power / PWRCurrentMaxPower) * 100)
		mainFrame.Percent:SetText(percent .. "%")
	end
end

function PWRFadeOut()
	local alpha = mainFrame:GetAlpha();
	if (alpha ~= 0) then mainFrame:SetAlpha(alpha - .05); end
	if (alpha == 0) then
		mainFrame:SetScript("OnUpdate", nil)
		mainFrame:Hide();
	end
end

function PWRReadableNumber(num, places)
    local ret
    local placeValue = ("%%.%df"):format(places or 0)
    if not num then
        return 0
    elseif num >= 1000000000000 then
        ret = placeValue:format(num / 1000000000000) .. "t" -- trillion
    elseif num >= 1000000000 then
        ret = placeValue:format(num / 1000000000) .. "b" -- billion
    elseif num >= 1000000 then
        ret = placeValue:format(num / 1000000) .. "m" -- million
    elseif num >= 1000 then
        ret = placeValue:format(num / 1000) .. "k" -- thousand
    else
        ret = num -- hundreds
    end
    return ret
end
