
mainFrame = CreateFrame("StatusBar", PWRAddonName .. "Frame", UIParent)
mainFrame:RegisterEvent("ADDON_LOADED")
mainFrame:RegisterEvent("PLAYER_LOGIN")
mainFrame:RegisterEvent("UNIT_POWER_FREQUENT") -- when power quantity change
mainFrame:RegisterEvent("PLAYER_REGEN_DISABLED") -- Enter combat
mainFrame:RegisterEvent("PLAYER_REGEN_ENABLED") -- Exit combat
mainFrame:RegisterEvent("UNIT_DISPLAYPOWER") -- when power type change
mainFrame:RegisterEvent("UNIT_MAXPOWER") -- when max power change
mainFrame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")

mainFrame:SetStatusBarTexture(PWRBarSkins[1].Value)
mainFrame:GetStatusBarTexture():SetHorizTile(false)
mainFrame:RegisterForDrag("LeftButton")
mainFrame:SetSize(PWRDefaultBarWidth, 20)
mainFrame:SetPoint("CENTER", 0, -150)
mainFrame:SetMovable(true)
mainFrame:EnableMouse(true)
mainFrame:SetClampedToScreen(true)
mainFrame:SetScript("OnDragStart", mainFrame.StartMoving)
mainFrame:SetScript("OnDragStop", function(self)
	self:StopMovingOrSizing()
	local currentSpecID = GetSpecialization()
	PerSettings.SpecsInfo[currentSpecID].XPos = self:GetLeft()
	PerSettings.SpecsInfo[currentSpecID].YPos = self:GetBottom()
end)

mainFrame.Border = mainFrame:CreateTexture(nil, "OVERLAY")
mainFrame.Border:SetPoint("TOPLEFT", -38, 12)
mainFrame.Border:SetPoint("BOTTOMRIGHT", 38, -12)

mainFrame.BG = mainFrame:CreateTexture(nil, "BACKGROUND")
mainFrame.BG:SetAllPoints(mainFrame)

mainFrame.Current = mainFrame:CreateFontString(nil, "OVERLAY")
mainFrame.Current:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
mainFrame.Current:SetText("0")
mainFrame.Current:SetPoint("LEFT", 8, 0)

mainFrame.Percent = mainFrame:CreateFontString(nil, "OVERLAY")
mainFrame.Percent:SetFont("Fonts\\FRIZQT__.TTF", 14, "OUTLINE")
mainFrame.Percent:SetText("100%")
mainFrame.Percent:SetPoint("CENTER", 0, -1)

mainFrame.Max = mainFrame:CreateFontString(nil, "OVERLAY")
mainFrame.Max:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
mainFrame.Max:SetText("100")
mainFrame.Max:SetPoint("RIGHT", -8, 0)

mainFrame:SetScript("OnEvent", function(self, event, ...)
	if (event == "UNIT_POWER_FREQUENT") then
		PWRPowerUpdate(...)
	elseif (event == "PLAYER_REGEN_DISABLED") then
		if (PWRLoaded) then
			local currentSpecID = GetSpecialization()
			if (PerSettings.SpecsInfo[currentSpecID].IsOnlyInCombat and PerSettings.SpecsInfo[currentSpecID].ShowSpec) then
				PWRIsInCombat = true
				mainFrame:SetScript("OnUpdate", nil)
				mainFrame:SetAlpha(255)
				mainFrame:Show()
			end
		end
	elseif (event == "PLAYER_REGEN_ENABLED") then
		if (PWRLoaded) then
			PWRIsInCombat = false
			local currentSpecID = GetSpecialization()
			if (PerSettings.SpecsInfo[currentSpecID].IsOnlyInCombat and PerSettings.SpecsInfo[currentSpecID].ShowSpec) then
				mainFrame:SetScript("OnUpdate", PWRFadeOut)
			end
		end
	elseif (event == "UNIT_DISPLAYPOWER") then
		PWRRefreshPowerColor(GetSpecialization())
	elseif (event == "UNIT_MAXPOWER") then
		PWRRefreshPowerRange()
	elseif (event == "ACTIVE_TALENT_GROUP_CHANGED") then
		if (PWRLoaded) then
			local currentSpecID = GetSpecialization()
			mainFrame:SetStatusBarTexture(PerSettings.SpecsInfo[currentSpecID].BarSkin)
			mainFrame.BG:SetTexture(PerSettings.SpecsInfo[currentSpecID].BarSkin)
			
			PWRSetVisible(mainFrame.Border, PerSettings.SpecsInfo[currentSpecID].BorderChoice)
			mainFrame.Border:SetTexture(PerSettings.SpecsInfo[currentSpecID].BorderChoice)
			
			PWRSetVisible(mainFrame.Current, PerSettings.SpecsInfo[currentSpecID].ShowCurrent)
			PWRSetVisible(mainFrame.Percent, PerSettings.SpecsInfo[currentSpecID].ShowPercent)
			PWRSetVisible(mainFrame.Max, PerSettings.SpecsInfo[currentSpecID].ShowMax)
			
			if (PerSettings.SpecsInfo[currentSpecID].XPos) then
				mainFrame:ClearAllPoints()
				mainFrame:SetPoint("BOTTOMLEFT", PerSettings.SpecsInfo[currentSpecID].XPos, PerSettings.SpecsInfo[currentSpecID].YPos)
			else
				mainFrame:ClearAllPoints()
				mainFrame:SetPoint("CENTER", 0, -150)
			end
			PWRRefreshLength(currentSpecID)
			if (not PerSettings.SpecsInfo[currentSpecID].IsOnlyInCombat) then
				mainFrame:Show()
			end
			if (not PerSettings.SpecsInfo[currentSpecID].ShowSpec) then
				mainFrame:Hide()
			end
		end
	elseif (event == "PLAYER_LOGIN") then
		PWRLoadAddon()
	end
end)
